connect /

drop table t;
drop table t2;
set echo on


clear screen
create table t as 
select rownum x, object_name 
  from big_table.big_table where rownum < 500000;
create index t_idx on t(x,object_name);
select num_rows from user_indexes where index_name = 'T_IDX';
pause

clear screen
analyze index t_idx validate structure;
create table t2
as
select 'before' when, index_stats.* from index_stats;
pause

clear screen
delete from t where mod(x,2) = 0;
commit;
pause
set timing off
clear screen
analyze index t_idx validate structure;
insert into t2
select 'middle' when, index_stats.* from index_stats;
pause

clear screen
alter index t_idx coalesce;
pause

clear screen
analyze index t_idx validate structure;
insert into t2
select 'coales' when, index_stats.* from index_stats;
pause


clear screen
alter index t_idx rebuild;
pause

clear screen
analyze index t_idx validate structure;
insert into t2
select 'rebuil' when, index_stats.* from index_stats;
pause

clear screen
set pause on
with data
as 
( select when, thing, val 
    from t2
  unpivot ( val for thing in 
            ( LF_ROWS, LF_BLKS, LF_ROWS_LEN, LF_BLK_LEN, 
              BR_ROWS, BR_BLKS, BR_ROWS_LEN, BR_BLK_LEN, 
              DEL_LF_ROWS, DEL_LF_ROWS_LEN, DISTINCT_KEYS, 
              MOST_REPEATED_KEY, BTREE_SPACE, USED_SPACE,
              PCT_USED, ROWS_PER_KEY, BLKS_GETS_PER_ACCESS,
              PRE_ROWS, PRE_ROWS_LEN, OPT_CMPR_COUNT, OPT_CMPR_PCTSAVE )
          )
)
select THING, before, middle, coalesce, rebuild, rebuild-coalesce diff
  from data
 pivot( max(val) for when in ( 'before' as before, 'middle' as middle, 
                               'coales' as coalesce, 'rebuil' as rebuild ) 
      )
 order by thing
/
pause
set pause off
